diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/UnifiedLoaderRepository3.java trunk/org/jboss/mx/loading/UnifiedLoaderRepository3.java
--- 6.0.0.M1/org/jboss/mx/loading/UnifiedLoaderRepository3.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/UnifiedLoaderRepository3.java	2009-12-10 12:42:46.000000000 -0600
@@ -21,40 +21,38 @@
  */
 package org.jboss.mx.loading;
 
+import java.io.IOException;
 import java.lang.ref.WeakReference;
 import java.net.MalformedURLException;
 import java.net.URL;
 import java.net.URLClassLoader;
 import java.util.ArrayList;
 import java.util.Collections;
+import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
-import java.util.Enumeration;
 import java.util.Map;
 import java.util.Set;
-import java.util.TreeSet;
-import java.io.IOException;
+import java.util.concurrent.ConcurrentHashMap;
+import java.util.concurrent.CopyOnWriteArraySet;
 
 import javax.management.ListenerNotFoundException;
 import javax.management.MBeanNotificationInfo;
+import javax.management.MBeanRegistration;
+import javax.management.MBeanServer;
 import javax.management.Notification;
 import javax.management.NotificationBroadcaster;
 import javax.management.NotificationFilter;
 import javax.management.NotificationListener;
-import javax.management.MBeanRegistration;
 import javax.management.ObjectName;
-import javax.management.MBeanServer;
 import javax.management.loading.MLet;
 
 import org.jboss.logging.Logger;
 import org.jboss.mx.util.JBossNotificationBroadcasterSupport;
 import org.jboss.util.Classes;
 
-import EDU.oswego.cs.dl.util.concurrent.ConcurrentReaderHashMap;
-import EDU.oswego.cs.dl.util.concurrent.CopyOnWriteArraySet;
-
 /** A repository of class loaders that form a flat namespace of classes
  * and resources. This version uses UnifiedClassLoader3 instances. Class
  * and resource loading is synchronized by the acquiring the monitor to the
@@ -63,7 +61,7 @@
  *
  * @author  <a href="mailto:scott.stark@jboss.org">Scott Stark</a>.
  * @author  <a href="mailto:Adrian.Brock@HappeningTimes.com">Adrian Brock</a>.
- * @version $Revision: 68584 $
+ * @version $Revision: 85671 $
  * just a hint... xdoclet not really used
  * @jmx.name="JMImplementation:service=UnifiedLoaderRepository,name=Default"
  */
@@ -93,54 +91,54 @@
    /** HashSet<UCL> of classloaders in the repository.
     * Access synchronized via this.classLoaders monitor.
     */
-   private CopyOnWriteArraySet classLoaders = new CopyOnWriteArraySet();
+   private CopyOnWriteArraySet<ClassLoader> classLoaders = new CopyOnWriteArraySet<ClassLoader>();
    /** HashSet<UCL> of class loaders in the repository that have a dynamic
     * URL associated with them. Such a class loader is added to every package
     * class loader set in #getPackageClassLoaders(String).
     */
-   private HashSet dynamicClassLoaders = new HashSet();
+   private HashSet<ClassLoader> dynamicClassLoaders = new HashSet<ClassLoader>();
    /** A HashMap<ClassLoader, UCL> of foreign (non-UCL) classloaders that
     * have been added to the repository as the key and the value the UCL
     * actually used by the ULR.
     * Access synchronized via this.classLoaders monitor.
     */
-   private HashMap nonUCLClassLoader = new HashMap();
+   private HashMap<ClassLoader, ClassLoader> nonUCLClassLoader = new HashMap<ClassLoader, ClassLoader>();
 
    /** A HashSet<URL> used to check for duplicate URLs. Previously this was handled
     by the UCL.equals, but this caused problems with Class.forName(String,
     boolean, ClassLoader) caching.
     Access synchronized via this.classLoaders monitor.
     */
-   private HashSet classLoaderURLs = new HashSet();
+   private HashSet<URL> classLoaderURLs = new HashSet<URL>();
 
    /** The loaded classes cache, HashMap<String, Class>.
     * Access synchronized via this.classes monitor.
     */
-   private ConcurrentReaderHashMap classes = new ConcurrentReaderHashMap();
+   private ConcurrentHashMap<String, Class<?>> classes = new ConcurrentHashMap<String, Class<?>>();
 
    /** HashMap<UCL, HashSet<String>> class loaders to the set of class names
     * loaded via the UCL.
     * Access synchronized via this.classes monitor.
     */
-   private HashMap loaderToClassesMap = new HashMap();
+   private HashMap<ClassLoader, HashSet<String>> loaderToClassesMap = new HashMap<ClassLoader, HashSet<String>>();
 
    /** HashMap<UCL, HashMap<String, URL>> class loaders to the set of
     * resource names they looked up.
     * Access synchronized via this.loaderToResourcesMap monitor.
     */
-   private HashMap loaderToResourcesMap = new HashMap();
+   private HashMap<ClassLoader, HashMap<String, URL>> loaderToResourcesMap = new HashMap<ClassLoader, HashMap<String, URL>>();
 
    /** HashMap<String, ResourceInfo(URL, UCL)> of global resources not unique
     * to a UCL
     * Access synchronized via this.loaderToResourcesMap monitor.
     */
-   private HashMap globalResources = new HashMap();
+   private HashMap<String, ResourceInfo<ClassLoader>> globalResources = new HashMap<String, ResourceInfo<ClassLoader>>();
 
    /** A HashMap<String, Set<UCL>> of package names to the set of
     * ClassLoaders which have classes in the package.
     * Access synchronized via this.packagesMap monitor.
     */
-   private ConcurrentReaderHashMap packagesMap = new ConcurrentReaderHashMap();
+   private ConcurrentHashMap<String, Set<ClassLoader>> packagesMap = new ConcurrentHashMap<String, Set<ClassLoader>>();
 
    /** A HashMap<UCL, String[]> of class loaders to the array of pckages names
     * they serve
@@ -220,16 +218,16 @@
       }
    }
 
-   public Class getCachedClass(String classname)
+   public Class<?> getCachedClass(String classname)
    {
-      return (Class) classes.get(classname);
+      return classes.get(classname);
    }
 
    /** Unlike other implementations of LoaderRepository, this method does
     * nothing but ask the UnifiedClassLoader3 to load the class as UCL3s
     * do not use this method.
     */
-   public Class loadClass(String name, boolean resolve, ClassLoader cl) throws ClassNotFoundException
+   public Class<?> loadClass(String name, boolean resolve, ClassLoader cl) throws ClassNotFoundException
    {
       RepositoryClassLoader rcl = getRepositoryClassLoader(cl, name);
       return rcl.loadClass(name, resolve);
@@ -238,7 +236,7 @@
    /** Called by LoadMgr to obtain all class loaders for the given className
     * @return Set<UnifiedClassLoader3>, may be null
     */
-   public Set getPackageClassLoaders(String className)
+   public Set<ClassLoader> getPackageClassLoaders(String className)
    {
       String pkgName = ClassLoaderUtils.getPackageName(className);
       
@@ -246,10 +244,10 @@
       if (pkgName.startsWith("java."))
          return null;
 
-      Set pkgSet = (Set) packagesMap.get(pkgName);
+      Set<ClassLoader> pkgSet = packagesMap.get(pkgName);
       if (dynamicClassLoaders.size() > 0)
       {
-         Set<RepositoryClassLoader> newSet = ClassLoaderUtils.newPackageSet();
+         Set<ClassLoader> newSet = ClassLoaderUtils.newPackageSet();
          if(pkgSet != null)
             newSet.addAll(pkgSet);
          pkgSet = newSet;
@@ -271,12 +269,12 @@
     * @param name the fully qualified class name
     * @return the cached Class if found, null otherwise
     */
-   public Class loadClassFromCache(String name)
+   public Class<?> loadClassFromCache(String name)
    {
-      Class cls = null;
+      Class<?> cls = null;
       synchronized (classes)
       {
-         cls = (Class) classes.get(name);
+         cls = classes.get(name);
       }
       return cls;
    }
@@ -286,7 +284,7 @@
     * @param cls the Class instance
     * @param cl the repository UCL
     */
-   public void cacheLoadedClass(String name, Class cls, ClassLoader cl)
+   public void cacheLoadedClass(String name, Class<?> cls, ClassLoader cl)
    {
       synchronized (classes)
       {
@@ -300,21 +298,21 @@
 
          // Update the cache for this classloader
          // This is used to cycling classloaders
-         HashSet loadedClasses = (HashSet) loaderToClassesMap.get(cl);
+         HashSet<String> loadedClasses = loaderToClassesMap.get(cl);
          if (loadedClasses == null)
          {
-            loadedClasses = new HashSet();
+            loadedClasses = new HashSet<String>();
             loaderToClassesMap.put(cl, loadedClasses);
          }
          loadedClasses.add(name);
       }
    }
 
-   Class loadClassFromClassLoader(String name, boolean resolve, RepositoryClassLoader cl)
+   Class<?> loadClassFromClassLoader(String name, boolean resolve, RepositoryClassLoader cl)
    {
       try
       {
-         Class cls = cl.loadClassLocally(name, resolve);
+         Class<?> cls = cl.loadClassLocally(name, resolve);
          cacheLoadedClass(name, cls, cl);
          return cls;
       }
@@ -372,22 +370,22 @@
     * @param cl the requesting class loader
     * @param urls a list into which the located resource URLs will be placed
     */
-   public void getResources(String name, ClassLoader cl, List urls)
+   public void getResources(String name, ClassLoader cl, List<URL> urls)
    {
       // Go through all class loaders
-      Iterator iter = classLoaders.iterator();
+      Iterator<ClassLoader> iter = classLoaders.iterator();
       while (iter.hasNext() == true)
       {
-         ClassLoader nextCL = (ClassLoader) iter.next();
+         ClassLoader nextCL = iter.next();
          if (nextCL instanceof RepositoryClassLoader)
          {
             RepositoryClassLoader ucl = (RepositoryClassLoader) nextCL;
             try
             {
-               Enumeration resURLs = ucl.findResourcesLocally(name);
+               Enumeration<URL> resURLs = ucl.findResourcesLocally(name);
                while (resURLs.hasMoreElements())
                {
-                  Object res = resURLs.nextElement();
+                  URL res = resURLs.nextElement();
                   urls.add(res);
                }
             }
@@ -413,8 +411,8 @@
       {
          if (loaderToResourcesMap.containsKey(cl))
          {
-            HashMap resources = (HashMap) loaderToResourcesMap.get(cl);
-            resource = (URL) resources.get(name);
+            HashMap<String, URL> resources = loaderToResourcesMap.get(cl);
+            resource = resources.get(name);
          }
       }
       return resource;
@@ -435,14 +433,14 @@
    /** Check for a resource in the global cache
     * Synchronizes access to globalResources using the loaderToResourcesMap monitor
     * @param name
-    * @return
+    * @return the URL
     */
    protected URL getResourceFromGlobalCache(String name)
    {
-      ResourceInfo ri = null;
+      ResourceInfo<ClassLoader> ri = null;
       synchronized (loaderToResourcesMap)
       {
-         ri = (ResourceInfo) globalResources.get(name);
+         ri = globalResources.get(name);
       }
       URL resource = null;
       if (ri != null)
@@ -454,8 +452,8 @@
    {
       // Get the set of class loaders from the packages map
       String pkgName = getResourcePackageName(name);
-      Iterator i = null;
-      Set pkgSet = (Set) this.packagesMap.get(pkgName);
+      Iterator<ClassLoader> i = null;
+      Set<ClassLoader> pkgSet = this.packagesMap.get(pkgName);
       if (pkgSet != null)
       {
          i = pkgSet.iterator();
@@ -469,7 +467,7 @@
       URL url = null;
       while (i.hasNext() == true)
       {
-         ClassLoader classloader = (ClassLoader) i.next();
+         ClassLoader classloader = i.next();
          if (classloader.equals(cl))
          {
             continue;
@@ -504,10 +502,10 @@
       // This is used for cycling classloaders
       synchronized (loaderToResourcesMap)
       {
-         HashMap resources = (HashMap) loaderToResourcesMap.get(cl);
+         HashMap<String, URL> resources = loaderToResourcesMap.get(cl);
          if (resources == null)
          {
-            resources = new HashMap();
+            resources = new HashMap<String, URL>();
             loaderToResourcesMap.put(cl, resources);
          }
          resources.put(name, url);
@@ -523,7 +521,7 @@
    {
       synchronized (loaderToResourcesMap)
       {
-         globalResources.put(name, new ResourceInfo(url, cl));
+         globalResources.put(name, new ResourceInfo<ClassLoader>(url, cl));
       }
    }
 
@@ -533,11 +531,11 @@
     */
    public URL[] getURLs()
    {
-      HashSet classpath = new HashSet();
-      Set tmp = classLoaders;
-      for (Iterator iter = tmp.iterator(); iter.hasNext();)
+      HashSet<URL> classpath = new HashSet<URL>();
+      Set<ClassLoader> tmp = classLoaders;
+      for (Iterator<ClassLoader> iter = tmp.iterator(); iter.hasNext();)
       {
-         Object obj = iter.next();
+         ClassLoader obj = iter.next();
          if (obj instanceof RepositoryClassLoader)
          {
             RepositoryClassLoader cl = (RepositoryClassLoader) obj;
@@ -568,7 +566,7 @@
       String classRsrcName = className.replace('.', '/') + ".class";
 
       int count = 0;
-      Class loadedClass = this.loadClassFromCache(className);
+      Class<?> loadedClass = this.loadClassFromCache(className);
       StringBuffer results = new StringBuffer(className + " Information\n");
       if (loadedClass != null)
       {
@@ -579,8 +577,8 @@
       {
          results.append("Not loaded in repository cache\n");
       }
-      Set tmp = classLoaders;
-      for (Iterator iter = tmp.iterator(); iter.hasNext();)
+      Set<ClassLoader> tmp = classLoaders;
+      for (Iterator<ClassLoader> iter = tmp.iterator(); iter.hasNext();)
       {
          URLClassLoader cl = (URLClassLoader) iter.next();
          URL classURL = cl.findResource(classRsrcName);
@@ -615,13 +613,13 @@
     * class loader.
     * @param className - the class to load
     */
-   public Class loadClass(String className) throws ClassNotFoundException
+   public Class<?> loadClass(String className) throws ClassNotFoundException
    {
       // Try to load from a UCL in the ULR first
       ClassLoader scl = Thread.currentThread().getContextClassLoader();
       ClassLoader ucl = null;
       if (classLoaders.size() > 0)
-         ucl = (ClassLoader) this.classLoaders.iterator().next();
+         ucl = this.classLoaders.iterator().next();
       try
       {
          if (ucl != null)
@@ -643,7 +641,7 @@
       }
 
       // at last try a native
-      Class clazz = getNativeClassForName(className);
+      Class<?> clazz = getNativeClassForName(className);
       if (clazz != null) return clazz;
 
       throw new ClassNotFoundException(className);
@@ -658,7 +656,7 @@
     * @return the found class
     * @exception ClassNotFoundException when there is no such class
     */
-   public Class loadClassWithout(ClassLoader loader, String className)
+   public Class<?> loadClassWithout(ClassLoader loader, String className)
            throws ClassNotFoundException
    {
       throw new ClassNotFoundException("NYI");
@@ -675,7 +673,7 @@
     * @throws ClassNotFoundException if none of the consulted classloaders were
     *                                able to load the requested class
     */
-   public Class loadClassBefore(ClassLoader stop, String className) throws ClassNotFoundException
+   public Class<?> loadClassBefore(ClassLoader stop, String className) throws ClassNotFoundException
    {
       RepositoryClassLoader stopAt = getRepositoryClassLoader(stop, className);
       return stopAt.loadClassBefore(className);
@@ -857,6 +855,7 @@
    /** Remove the class loader from the repository. This synchronizes on the
     * this.classLoaders
     */
+   @SuppressWarnings("unchecked")
    public void removeClassLoader(ClassLoader loader)
    {
       ArrayList removeNotifications = new ArrayList();
@@ -865,7 +864,7 @@
       {
          if ((loader instanceof RepositoryClassLoader) == false)
          {
-            cl = (ClassLoader) nonUCLClassLoader.remove(loader);
+            cl = nonUCLClassLoader.remove(loader);
          }
          if (cl instanceof RepositoryClassLoader)
          {
@@ -887,7 +886,7 @@
          {
             hasLoadedClasses = loaderToClassesMap.containsKey(cl);
             if (hasLoadedClasses)
-               loadedClasses = (HashSet) loaderToClassesMap.remove(cl);
+               loadedClasses = loaderToClassesMap.remove(cl);
             // This classloader has loaded at least one class
             if (loadedClasses != null)
             {
@@ -914,7 +913,7 @@
          {
             if (loaderToResourcesMap.containsKey(cl))
             {
-               HashMap resources = (HashMap) loaderToResourcesMap.remove(cl);
+               HashMap<String, URL> resources = loaderToResourcesMap.remove(cl);
 
                // Remove the resources from the global cache that are from this classloader
                if (resources != null)
@@ -922,7 +921,7 @@
                   for (Iterator i = resources.keySet().iterator(); i.hasNext();)
                   {
                      String name = (String) i.next();
-                     ResourceInfo ri = (ResourceInfo) globalResources.get(name);
+                     ResourceInfo ri = globalResources.get(name);
                      if (ri != null && ri.cl == cl)
                         globalResources.remove(name);
                   }
@@ -938,10 +937,10 @@
             {
                for(String pkgName : pkgNames)
                {
-                  Set pkgSet = (Set) packagesMap.get(pkgName);
+                  Set<ClassLoader> pkgSet = packagesMap.get(pkgName);
                   if (pkgSet != null)
                   {
-                     Set<RepositoryClassLoader> newSet = ClassLoaderUtils.newPackageSet();
+                     Set<ClassLoader> newSet = ClassLoaderUtils.newPackageSet();
                      newSet.addAll(pkgSet);
                      pkgSet = newSet;
 
@@ -957,15 +956,15 @@
          {
             // A dynamic classloader could end up in any package set
             loaderToPackagesMap.remove(cl);
-            for (Iterator i = packagesMap.entrySet().iterator(); i.hasNext();)
+            for (Iterator<Map.Entry<String, Set<ClassLoader>>> i = packagesMap.entrySet().iterator(); i.hasNext();)
             {
-               Map.Entry entry = (Map.Entry) i.next();
-               Set pkgSet = (Set) entry.getValue();
+               Map.Entry<String, Set<ClassLoader>> entry = i.next();
+               Set<ClassLoader> pkgSet = entry.getValue();
                if(pkgSet.contains(cl))
                {
                   if(pkgSet.size() > 1)
                   {
-                     Set<RepositoryClassLoader> newSet = ClassLoaderUtils.newPackageSet();
+                     Set<ClassLoader> newSet = ClassLoaderUtils.newPackageSet();
                      newSet.addAll(pkgSet);
                      newSet.remove(cl);
                      packagesMap.put(entry.getKey(), newSet);
@@ -1015,7 +1014,7 @@
       {
          Notification msg = new Notification(CLASSLOADER_ADDED, this, getNextSequenceNumber());
          if (NOTIFICATION_MODE == WEAK_REFERENCE_MODE)
-            msg.setUserData(new WeakReference(ucl));
+            msg.setUserData(new WeakReference<ClassLoader>(ucl));
          else
             msg.setUserData(ucl);
          broadcaster.sendNotification(msg);
@@ -1150,7 +1149,7 @@
          if( pkgName.startsWith("META-INF") || pkgName.startsWith("WEB-INF") )
             return;
 
-         Set<RepositoryClassLoader> pkgSet = (Set<RepositoryClassLoader>) packagesMap.get(pkgName);
+         Set<ClassLoader> pkgSet = packagesMap.get(pkgName);
          if( pkgSet == null )
          {
             pkgSet = ClassLoaderUtils.newPackageSet();
@@ -1159,17 +1158,17 @@
          if( pkgSet.contains(loader) == false )
          {
             // Make a copy of the pkgSet to avoid concurrent mods
-            Set<RepositoryClassLoader> newSet = ClassLoaderUtils.newPackageSet();
+            Set<ClassLoader> newSet = ClassLoaderUtils.newPackageSet();
             newSet.addAll(pkgSet);
             pkgSet = newSet;
             // Add the class loader
-            pkgSet.add((RepositoryClassLoader)loader);
+            pkgSet.add(loader);
             packagesMap.put(pkgName, newSet);
             List<String> loaderPkgNames = loaderToPackagesMap.get(loader);
             if( loaderPkgNames == null )
             {
                loaderPkgNames = new ArrayList<String>();
-               loaderToPackagesMap.put((RepositoryClassLoader)loader, loaderPkgNames);
+               loaderToPackagesMap.put(loader, loaderPkgNames);
             }
             loaderPkgNames.add(pkgName);
 
diff -EbwBru 6.0.0.M1/org/jboss/mx/loading/UnifiedLoaderRepository3MBean.java trunk/org/jboss/mx/loading/UnifiedLoaderRepository3MBean.java
--- 6.0.0.M1/org/jboss/mx/loading/UnifiedLoaderRepository3MBean.java	2009-11-30 14:38:49.000000000 -0600
+++ trunk/org/jboss/mx/loading/UnifiedLoaderRepository3MBean.java	2009-12-10 12:42:46.000000000 -0600
@@ -26,18 +26,21 @@
 /** The UnifiedLoaderRepository3 (ULR) management interface
  *
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81022 $
+ * @version $Revision: 85671 $
  */
 public interface UnifiedLoaderRepository3MBean extends UnifiedLoaderRepositoryMBean
 {
    /** Called by LoadMgr to obtain all class loaders for the given className
+    * @param className 
     *@return LinkedList<UnifiedClassLoader3>, may be null
     */
-   public Set getPackageClassLoaders(String className);
+   public Set<ClassLoader> getPackageClassLoaders(String className);
 
    /** A utility method that iterates over all repository class loader and
     * display the class information for every UCL that contains the given
     * className
+    * @param className 
+    * @return the class info
     */
    public String displayClassInfo(String className);
 
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/AbstractBuilder.java trunk/org/jboss/mx/metadata/AbstractBuilder.java
--- 6.0.0.M1/org/jboss/mx/metadata/AbstractBuilder.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/AbstractBuilder.java	2009-12-10 12:42:23.000000000 -0600
@@ -35,7 +35,7 @@
  * @see org.jboss.mx.metadata.MetaDataBuilder
  *
  * @author  <a href="mailto:juha@jboss.org">Juha Lindfors</a>.
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  *
  */
 public abstract class AbstractBuilder
@@ -47,7 +47,7 @@
    /**
     * Configuration properties.
     */
-   protected Map properties = new HashMap();
+   protected Map<String, Object> properties = new HashMap<String, Object>();
 
    // Constructors --------------------------------------------------
 
@@ -56,7 +56,7 @@
     */
    public AbstractBuilder() {}
 
-   public AbstractBuilder(Map properties)
+   public AbstractBuilder(Map<String, Object> properties)
    {
       this.properties = properties;
    }
@@ -105,6 +105,9 @@
 
    /**
     * Returns a string property or <tt>null</tt> if key does not exist.
+    * 
+    * @param key the key
+    * @return the property
     */
    public String getStringProperty(String key)
    {
@@ -139,15 +142,17 @@
     *
     * @param   properties  configuration properties
     */
-   protected void setProperties(Map properties)
+   protected void setProperties(Map<String, Object> properties)
    {
-      this.properties = new HashMap(properties);
+      this.properties = new HashMap<String, Object>(properties);
    }
 
    /**
     * Returns the property map of this builder instance.
+    * 
+    * @return the properties
     */
-   protected Map getProperties()
+   protected Map<String, Object> getProperties()
    {
       return properties;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/AttributeOperationResolver.java trunk/org/jboss/mx/metadata/AttributeOperationResolver.java
--- 6.0.0.M1/org/jboss/mx/metadata/AttributeOperationResolver.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/AttributeOperationResolver.java	2009-12-10 12:42:23.000000000 -0600
@@ -52,6 +52,8 @@
     * Uses the AttributeInfo and OperationInfo arrays in the MBeanInfo to configure the
     * resolver.  Each attribute and operation will be assigned a code which corresponds
     * to it's position in the info array.
+    * 
+    * @param info the mbean info
     */
    public AttributeOperationResolver(MBeanInfo info)
    {
@@ -61,7 +63,10 @@
    /**
     * Uses the AttributeInfo and OperationInfo arrays to configure the resolver.
     * Each attribute and operation will be assigned a code which corresponds to it's
-    * position in the info array.
+    * position in the info array
+    * 
+    * @param attributes the attributes
+    * @param operations the operations
     */
    public AttributeOperationResolver(MBeanAttributeInfo[] attributes, MBeanOperationInfo[] operations)
    {
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/JBossXMBean10.java trunk/org/jboss/mx/metadata/JBossXMBean10.java
--- 6.0.0.M1/org/jboss/mx/metadata/JBossXMBean10.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/JBossXMBean10.java	2009-12-10 12:42:23.000000000 -0600
@@ -59,8 +59,9 @@
  * @author Matt Munz
  * @author Scott.Stark@jboss.org
  * @author Dimitris.Andreadis@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 86129 $
  */
+@SuppressWarnings("unchecked")
 public class JBossXMBean10 extends AbstractBuilder
    implements XMBeanConstants
 {
@@ -424,12 +425,14 @@
          boolean isReadable = true;
          boolean isWritable = true;
 
+         if (access != null)
+         {
          if (access.equalsIgnoreCase("read-only"))
             isWritable = false;
 
          else if (access.equalsIgnoreCase("write-only"))
             isReadable = false;
-
+         }
 
          ModelMBeanAttributeInfo info = new ModelMBeanAttributeInfo(
             name, type, description, isReadable, isWritable, false, descr
@@ -447,6 +450,12 @@
    /**
     * Get the value for the attribute descriptor "value" or "default"
     * the same way we would do for mbean attribute overrides
+    * 
+    * @param attribute the attribute
+    * @param typeName the type name
+    * @param which ?
+    * @return the value
+    * @throws NotCompliantMBeanException for any error
     */
    protected Object getAttributeValue(Element attribute, String typeName, String which)
       throws NotCompliantMBeanException
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/MBeanCapability.java trunk/org/jboss/mx/metadata/MBeanCapability.java
--- 6.0.0.M1/org/jboss/mx/metadata/MBeanCapability.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/MBeanCapability.java	2009-12-10 12:42:23.000000000 -0600
@@ -22,6 +22,7 @@
 package org.jboss.mx.metadata;
 
 import javax.management.DynamicMBean;
+import javax.management.MBean;
 import javax.management.NotCompliantMBeanException;
 
 /**
@@ -59,22 +60,11 @@
    public static final int STANDARD_MBEAN = 0x123;
    public static final int NOT_AN_MBEAN = 0xc0de;
 
-   private static final MBeanCapability DYNAMIC_CONST = new MBeanCapability(DYNAMIC_MBEAN);
-   private static final MBeanCapability STANDARD_CONST = new MBeanCapability(STANDARD_MBEAN);
-
-   protected int mbeanType = NOT_AN_MBEAN;
-
-   private MBeanCapability(int type)
-   {
-      mbeanType = type;
-   }
-
-   public int getMBeanType()
+   private MBeanCapability()
    {
-      return mbeanType;
    }
 
-   public static MBeanCapability of(Class mbeanClass) throws NotCompliantMBeanException
+   public static int of(Class<?> mbeanClass) throws NotCompliantMBeanException
    {
       if (null == mbeanClass)
       {
@@ -84,22 +74,27 @@
       // If MyClass is an instance of the DynamicMBean interface, MyClass is a dynamic MBean.
       if (DynamicMBean.class.isAssignableFrom(mbeanClass))
       {
-         return DYNAMIC_CONST;
+         return DYNAMIC_MBEAN;
+      }
+
+      // Class is annotated with @MBean 
+      if (mbeanClass.isAnnotationPresent(MBean.class))
+      {
+         return STANDARD_MBEAN;
       }
 
       // If the MyClass MBean is an instance of a MyClassMBean interface, MyClass is a standard MBean
-      Class [] interfaces = mbeanClass.getInterfaces();
-      for (int i = 0; i < interfaces.length; i++)
+      Class<?> [] interfaces = mbeanClass.getInterfaces();
+      for (Class<?> anInterface : interfaces)
       {
-         Class anInterface = interfaces[i];
          if (anInterface.getName().equals(mbeanClass.getName() + "MBean"))
          {
-            return STANDARD_CONST;
+            return STANDARD_MBEAN;
          }
       }
 
       // If there is an ancestor called SuperClass that is an instance of SuperClassMBean
-      Class superClass = mbeanClass.getSuperclass();
+      Class<?> superClass = mbeanClass.getSuperclass();
       if (superClass != null)
          return of(superClass);
 
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/MBeanInfoConversion.java trunk/org/jboss/mx/metadata/MBeanInfoConversion.java
--- 6.0.0.M1/org/jboss/mx/metadata/MBeanInfoConversion.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/MBeanInfoConversion.java	2009-12-10 12:42:23.000000000 -0600
@@ -48,7 +48,7 @@
  * ModelMBeanOperationInfos that are referred to in ModelMBeanAttributeInfos.
  *
  * @author  <a href="mailto:juha@jboss.org">Juha Lindfors</a>.
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
 public class MBeanInfoConversion
    implements ModelMBeanConstants
@@ -57,6 +57,7 @@
     * Convert regular MBeanInfo into ModelMBeanInfo.
     *
     * @param   info  MBeanInfo to convert (such as the Standard MBean info)
+    * @return the model mbean info
     */
    public static ModelMBeanInfoSupport toModelMBeanInfo(MBeanInfo info)
    {
@@ -74,7 +75,9 @@
     *          attribute descriptors are mapped to appropriate management 
     *          operations with the <tt>getMethod</tt> and <tt>setMethod</tt>
     *          descriptor fields.
+    * @return the modelmbean info
     */
+   @SuppressWarnings("unchecked")
    public static ModelMBeanInfoSupport toModelMBeanInfo(MBeanInfo info, boolean createAttributeOperationMapping)
    {
       if (info instanceof ModelMBeanInfoSupport)
@@ -246,8 +249,14 @@
     * fields are stripped out.  If the stripAllRoles parameter is true
     * then all the referred-to operations will be stripped.  Otherwise only 
     * referred-to operations with a role of "getter" or "setter" will be stripped.
+    * 
+    * @param info the original info
+    * @param stripAllRoles see text
+    * @return the modelmbean info
+    * @throws MBeanException why?
     */
     // why mbeanexception?
+   @SuppressWarnings("unchecked")
    public static ModelMBeanInfoSupport stripAttributeOperations(ModelMBeanInfo info, boolean stripAllRoles) throws MBeanException
    {
       HashMap opsMap = new HashMap();
